
local doLoot = {}
local doLootSize = table.getn(doLoot);
local enabled = true;

function MyLoot_Loot()
  for i = 1, GetNumLootItems() do
    local lootIcon, lootName, lootQuantity, rarity, locked = GetLootSlotInfo(i);
    if locked == false then
      if (GetLootSlotType(i) == 1) then
        temp, temp, temp, temp, temp, itemType = GetItemInfo(GetLootSlotLink(i));
      end
      if (GetLootSlotType(i) == 2 or GetLootSlotType(i) == 3) then
  	    LootSlot(i);
      elseif MyLoot_ShouldILoot(lootName) then
  	    LootSlot(i);
  	  elseif noquest == nil and itemType == "Quest" then
  	      LootSlot(i);
      elseif nospam == nil then
  	    local s = "";
       	if lootQuantity > 1 then
  	      s = 'x'..lootQuantity;
  	    end
  	    if GetLootSlotLink(i) ~= nil then
          DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."Ignoring ".."|c00ffffff"..GetLootSlotLink(i).."|c00008800"..s..'.');
        end
      end
    end
  end
end

function MyLoot_ShouldILoot(name)
  for i = 1, table.getn(doLoot) do
    if GetItemInfo(doLoot[i]) == name then
	    return true;
    end
  end
end

function MyLoot_OnEvent(self, event, ...)
  if event=="LOOT_OPENED" and enabled == true then
    MyLoot_Loot();
  elseif event=="PLAYER_LOGIN" then
    DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot".."|c00ffffff".." v1.2 loaded. Typing \"/ml\" will give you a list of commands.");
    if LootList == nil then
      LootList = {}
    end
  elseif event=="PLAYER_LOGOUT" then
    LootList = doLoot;
  end
  doLoot = LootList;
  if doLoot == nil then
    doLoot = {}
  end
  doLootSize=table.getn(doLoot);
end

function MyLoot_RemoveItem(name)
  for i = 1, table.getn(doLoot) do
    if doLoot[i] == MyLoot_LinkSimple(name) then
	table.remove(doLoot,i);
	return true;
    end
  end
end

function MyLoot_ItemExists(name)
  for i = 1, table.getn(doLoot) do
    if doLoot[i] == MyLoot_LinkSimple(name) then
      return true;
    end
  end
end

function MyLoot_IsItemLink(name)
  if string.sub(name,1,2) == "|c" and string.sub(name,11,17) == "|Hitem:" and string.sub(name,string.len(name)-3,string.len(name)) == "|h|r" and string.find(string.sub(name,3),"|c") == nil then
    return true;
  else
    return false;
  end
end

function MyLoot_TrimSpaces(arg)
  while string.sub(arg,1,1) == " " do
    arg = string.sub(arg,2);
  end 
  return arg;
end

function MyLoot_LinkSimple(link)
  return string.sub(link,1,string.find(link,":",18)-1)..string.sub(link,string.find(link,"|",18),-1);
end

function MyLoot_SlashCmdHandler(arg)
  if string.len(arg) > 6 and string.sub(arg,1,6) == "remove" then
  arg = "rem"..string.sub(arg,7,string.len(arg));
  end
  if string.len(arg) > 3 and string.sub(arg,1,3) == "add" then
    local linkSize = string.len(arg) - 4;
    local name = MyLoot_TrimSpaces(string.sub(arg,4));
    if MyLoot_IsItemLink(name) == false then
      DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." this is not item link.");
    elseif MyLoot_ItemExists(name) then
      DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." item is aleready autolooted.");
    else
      doLoot[doLootSize+1] = MyLoot_LinkSimple(name);
      doLootSize = doLootSize + 1;
      DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." item added to loot list: "..name.."|c00ffffff"..".");
    end
  elseif string.len(arg) > 3 and string.sub(arg,1,3) == "rem" then
    name = MyLoot_TrimSpaces(string.sub(arg,4));
    if MyLoot_IsItemLink(name) == false then
      DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." this is not item link.");
    elseif MyLoot_RemoveItem(name) == true then
      doLootSize = doLootSize - 1;
      DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." item removed from loot list: "..name.."|c00ffffff"..".");
    else
      DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." no such item in lootlist."); 
    end
  elseif string.len(arg) == 3 and string.sub(arg,1,3) == "off" then
    enabled = false;
    DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." temporarily ".."|c00ff0000".."suspended".."|c00ffffff"..".");
  elseif string.len(arg) == 2 and string.sub(arg,1,2) == "on" then
    enabled = true;
    DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c0000ff00".." enabled".."|c00ffffff".." again.");
  elseif string.len(arg) == 4 and string.sub(arg,1,4) == "list" then
    DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." list of autolooted items:");
    temp = " ";
    for i = 1, table.getn(doLoot) do
      temp = temp..doLoot[i]..", ";
    end
    if temp == " " then
      temp = " No entries found  ";
    end
    DEFAULT_CHAT_FRAME:AddMessage(string.sub(temp,1,string.len(temp)-2)..".");
  elseif string.len(arg) == 4 and string.sub(arg,1,10) == "spam" then
    if nospam == nil then
      nospam = true;
      DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." Ignoring ".."|c00f0ff0f".."[Stuff]".."|c00ffffff".." messages ".."|c00ff0000".."disabled".."|c00ffffff"..".");
    else
      nospam = nil;
      DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." Ignoring ".."|c00f0ff0f".."[Stuff]".."|c00ffffff".." messages ".."|c0000ff00".."enabled".."|c00ffffff"..".");
    end
  elseif string.len(arg) == 5 and string.sub(arg,1,10) == "quest" then
    if noquest == nil then
      noquest = true;
      DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." Autoloot quest related items ".."|c00ff0000".."disabled".."|c00ffffff"..".");
    else
      noquest = nil;
      DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot:".."|c00ffffff".." Autoloot quest related items ".."|c0000ff00".."enabled".."|c00ffffff"..".");
    end    
  else
    DEFAULT_CHAT_FRAME:AddMessage("|c00008800".."MyLoot: ".."|c00ffffff".."command list:");
    DEFAULT_CHAT_FRAME:AddMessage(" /ml add ".."|c00f0ff0f".."[itemlink]".."|c00ffffff".." - Adds an item to the Loot list.");
    DEFAULT_CHAT_FRAME:AddMessage(" /ml rem ".."|c00f0ff0f".."[itemlink]".."|c00ffffff".." - Removes an item to the Loot list.");
    DEFAULT_CHAT_FRAME:AddMessage(" /ml off - Temporarily suspends addon activity.");
    DEFAULT_CHAT_FRAME:AddMessage(" /ml on - Resumes suspended addon activity.");
    DEFAULT_CHAT_FRAME:AddMessage(" /ml list - Shows current loot list.");
    DEFAULT_CHAT_FRAME:AddMessage(" /ml spam - Toggles \"Ignoring ".."|c00f0ff0f".."[Stuff]".."|c00ffffff".."\" messages on/off.");
    DEFAULT_CHAT_FRAME:AddMessage(" /ml quest - Toggles autoloot of quest related items.");
  end
end

SlashCmdList["MYLOOT"] = MyLoot_SlashCmdHandler;
SLASH_MYLOOT1 = "/ml";

local frame = CreateFrame("FRAME", "MyLootFrame");   
frame:RegisterEvent("LOOT_OPENED");
frame:RegisterEvent("ADDON_LOADED");
frame:RegisterEvent("PLAYER_LOGIN");
frame:RegisterEvent("PLAYER_LOGOUT");
frame:SetScript("OnEvent", MyLoot_OnEvent);